<?php
/**
 * @file
 * Displays the items of the accordion.
 */

  // Group our tasks according to Project ID.
  $parent_id = $view->options['parentid'];
  for ($rid = 0; $rid < count($view->result); $rid++) {
    $row = $view->result[$rid];
    // for each remaining row in the result after the 'current' row
    for ($i = $rid+1; $i < count($view->result); $i++) {
      if (isset($view->result[$i]->$parent_id)) {
        // if this row belongs to the same project as the 'current' row
        if ($view->result[$i]->$parent_id == $row->$parent_id) {
          // move this row up
          array_splice($view->result, $rid+1, 0, array($view->result[$i]));
          array_splice($view->result, $i+1, 1);
          break;
        }
      }
    }
  }

  // Get our field names.
  $task_title = $view->options['tasktitle'];
  $start_date = 'field_' . $view->options['startdate'];
  $end_date = 'field_' . $view->options['enddate'];
  $parentstart = 'field_' . $view->options['parentstart'];
  $parentend = 'field_' . $view->options['parentend'];
  $parent_id = $view->options['parentid'];
  $parent_title = $view->options['parenttitle'];


  // Store our field names in an array to pass to our 
  $settings = array(
    'task_title' => $view->options['tasktitle'],
    'start_date' => $view->options['startdate'],
    'end_date' => $view->options['enddate'],
    'parentstart' => $view->options['parentstart'],
    'parentend' => $view->options['parentend'],
    'parent_id' => $view->options['parentid'],
    'parent_title' => $view->options['parenttitle'],
    'tasktype' => $view->options['tasktype'],
    'parenttype' => $view->options['parenttype'],
  );

  // Add our main javascript file.
  drupal_add_js(array('ganttview' => $settings), 'setting');

  // Get parent ids and titles for use as headers.
  foreach($view->result as $row){
    if ($row->$parent_id) {
      $parents[$row->$parent_id] = array(
        'id' => $row->$parent_id,
        'title' => $row->$parent_title,
      );
    } 
  }

  // Get our parent data.
  foreach($view->result as $row){
    // Get our parent start dates.
    $parent_start = $row->$parentstart;
    if(isset($parent_start[0])) {
      $parent_start = $parent_start[0]['raw']['value'];
      $parent_start_year = substr($parent_start, 0, 4);
      $parent_start_month = (int)substr($parent_start, 5, 2);
      // Month count Starts at '0', so we must adjust.
      $parent_start_month = $parent_start_month -1;
      $parent_start_day = substr($parent_start, 8, 2);
    }
    // Get our parent end dates.
    $parent_end = $row->$parentend;
    if(isset($parent_end[0])) {
      $parent_end = $parent_end[0]['raw']['value'];
      $parent_end_year = substr($parent_end, 0, 4);
      $parent_end_month = (int)substr($parent_end, 5, 2);
      // Month count Starts at '0', so we must adjust.
      $parent_end_month = $parent_end_month -1;
      $parent_end_day = substr($parent_end, 8, 2);
    }
    if(isset($parent_start)) {
      $ganttParents[$row->$parent_id] = 'start: new Date('. $parent_start_year .','. $parent_start_month .','. $parent_start_day .'), end: new Date('. $parent_end_year .','. $parent_end_month .','. $parent_end_day .'),';
    }
  }

  // Filter out duplicates.
  $ganttParents = array_unique($ganttParents);

  foreach ($view->result as $row) {
    $title = $row->$task_title;

    // Get our start dates.
    $start = $row->$start_date;
    $start = $start[0]['raw']['value'];
    $start_year = substr($start, 0, 4);
    $start_month = (int)substr($start, 5, 2);
    // Month count Starts at '0', so we must adjust.
    $start_month = $start_month -1;
    $start_day = substr($start, 8, 2);

    // Get our end dates.
    $end = $row->$end_date;
    $end = $end[0]['raw']['value'];
    $end_year = substr($end, 0, 4);
    $end_month = (int)substr($end, 5, 2);
    // Month count Starts at '0', so we must adjust.
    $end_month = $end_month -1;
    $end_day = substr($end, 8, 2);
	
    // Set parent id, so we can match the tasks with the parents.
    $ganttData[$row->$parent_id]['js'][] = '{ nid: "' . $row->nid . '" , name: "' . $title . '", start: new Date('. $start_year .','. $start_month .','. $start_day .'), end: new Date('. $end_year .','. $end_month .','. $end_day .') },';
  }

  foreach ($parents as $parent) {
    $data = implode($ganttData[$parent['id']]['js']);
    if (isset($parent)) {
      $parent = $parent;
    }
    else { 
      $parent = rand();
    }
    if(isset($ganttParents[$parent['id']])){
      $list[] = '{id: ' . $parent['id'] . ', nid: "' . $parent['id'] . '", name: "' . $parent['title'] . '", ' . $ganttParents[$parent['id']] . ' series: [' . $data . ']},';
    }
    else {
      $list[] = '{id: ' . $parent['id'] . ', nid: "' . $parent['id'] . '", name: "'. $parent['title'] . '", series: [' . $data . ']},';
    }
  }

  // Combine all of our parents.
  $gantt = implode($list);

  // Finally set the javascript variable containing all our data.
  echo '<script type="text/javascript">';
  echo 'var ganttData = [' . $gantt . '];';
  echo '</script>';

?>

	<div id="ganttChart"></div>
	<br/><br/>
	<div id="eventMessage"></div>


	<script type="text/javascript">
		jQuery(function () {
			jQuery("#ganttChart").ganttView({ 
				data: ganttData,
				
				
			});
			
			 jQuery("#ganttChart").ganttView("setSlideWidth", 500);
		});
	</script>
